/*
    This file is part of Sarasvati.

    Sarasvati is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    Sarasvati is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with Sarasvati.  If not, see <http://www.gnu.org/licenses/>.

    Copyright 2008 Paul Lorenz
*/
package com.googlecode.sarasvati.mem;

import com.googlecode.sarasvati.External;
import com.googlecode.sarasvati.Graph;
import com.googlecode.sarasvati.env.ReadEnv;

public class MemExternal implements External
{
  protected String name;
  protected Graph graph;
  protected Graph externalGraph;

  protected ReadEnv env;

  public MemExternal (final String name, final Graph graph, final Graph externalGraph, final ReadEnv env)
  {
    this.name = name;
    this.graph = graph;
    this.externalGraph = externalGraph;
    this.env = env;
  }

  @Override
  public ReadEnv getEnv ()
  {
    return env;
  }

  @Override
  public Graph getExternalGraph ()
  {
    return externalGraph;
  }

  @Override
  public Graph getGraph ()
  {
    return graph;
  }

  @Override
  public String getName ()
  {
    return name;
  }
}
